VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00C0C0C0&
   Caption         =   " Calendar Functions Module Tester"
   ClientHeight    =   1680
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6420
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Icon            =   "Calendar.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1680
   ScaleWidth      =   6420
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command1 
      Caption         =   "RUN Test"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   465
      Left            =   5220
      TabIndex        =   2
      Top             =   135
      Width           =   1185
   End
   Begin VB.TextBox Text3 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   3465
      TabIndex        =   3
      Text            =   "Text3"
      Top             =   225
      Width           =   1635
   End
   Begin VB.TextBox Text2 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   1755
      TabIndex        =   1
      Text            =   "Text2"
      Top             =   225
      Width           =   1635
   End
   Begin VB.TextBox Text1 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   45
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   225
      Width           =   1635
   End
   Begin VB.Label Label1 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Result returned from function test"
      ForeColor       =   &H00000000&
      Height          =   960
      Left            =   45
      TabIndex        =   4
      Top             =   675
      Width           =   6315
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' This program is used to test the calendar functions in the attached Calendar.BAS module.
'
' Different functions and inputs can be substituted for the current ones to test the way
' the various functions work.
'
' Initialize default input variables in the text interface for calendar functions test.

Private Sub Form_Load()
'
' In this case the date validity check function,  Is_Valid_Date()  is being tested.
'
' Here the default arguments are defined when the program starts.
  Text1.Text = "15 Oct 1990" ' Used to hold a single date argument.
  Text2.Text = " "           ' Used to hold 2nd date when needed.
  Text3.Text = "G"           ' Used to hold the J|G calendar mode flag.
End Sub

Private Sub Command1_Click()
' Routine to test calendar functions modules.

  Dim JD_Number, Cal_Mode, Dd_Mmm_Yyyy_BCAD
  
  JD_Number = Text1.Text
  Cal_Mode = Text3.Text

' Compute JD number for date - No error checking done here.
  Label1.Caption = JD_Number_For(JD_Number, Cal_Mode)

' Reverse the process and compute original date string from the
' computed JD number. If working properly, then the output date
' should match the input date. No error checking done here.
  Label1.Caption = Label1.Caption & "    =  " & Date_Corresponding_To(Label1.Caption, Cal_Mode)
    
End Sub

Private Sub Text1_Change()
' Clear out (Label1) if first input argument is changed.
  Label1.Caption = ""
End Sub
Private Sub Text2_Change()
' Clear out (Label1) if second input argument is changed.
  Label1.Caption = ""
End Sub
Private Sub Text3_Change()
' Clear out (Label1) if third input argument is changed.
  Label1.Caption = ""
End Sub

