Attribute VB_Name = "modSpellNumber"
Private Function SpellAmount(DigitAmount As Currency) As String
    s = "*****"
    If DigitAmount < 1 Then s = s & "Zero"
    If DigitAmount > 999 Then THOUSANDS% = Fix(DigitAmount / 1000) Else THOUSANDS% = 0
    DigitAmount = DigitAmount - THOUSANDS% * 1000
    If DigitAmount > 99 Then HUNDREDS% = Fix(DigitAmount / 100) Else HUNDREDS% = 0
    DigitAmount = DigitAmount - HUNDREDS% * 100
    If DigitAmount > 9 Then TENS = Fix(DigitAmount / 10) Else TENS = 0
    DigitAmount = DigitAmount - TENS * 10
    ONES% = Fix(DigitAmount)
    CENTS = (DigitAmount - ONES%) * 100
    If THOUSANDS% > 0 Then s = s & SpellDigit(THOUSANDS%) & "Thousand "
    If HUNDREDS% > 0 Then s = s & SpellDigit(HUNDREDS%) & "Hundred "
    Select Case TENS
        Case 1
            Select Case ONES%
                Case 0
                    s = s & " Ten"
                Case 1
                    s = s & "Eleven"
                Case 2
                    s = s & "Twelve"
                Case 3
                    s = s & "Thirteen"
                Case 4
                    s = s & "Fourteen"
                Case 5
                    s = s & "Fifteen"
                Case 6
                    s = s & "Sixteen"
                Case 7
                    s = s & "Seventeen"
                Case 8
                    s = s & "Eighteen"
                Case 9
                    s = s & "Nineteen"
            End Select
        Case 2
            s = s & "Twenty"
        Case 3
            s = s & "Thirty"
        Case 4
            s = s & "Forty"
        Case 5
            s = s & "Fifty"
        Case 6
            s = s & "Sixty"
        Case 7
            s = s & "Seventy"
        Case 8
            s = s & "Eighty"
        Case 9
            s = s & "Ninety"
    End Select
    If TENS > 1 And ONES% > 0 Then s = s & "-"
    If ONES% > 0 And TENS <> 1 Then s = s & SpellDigit(ONES%)
    
    s = s & " and " & Format(CENTS, "00") & "/100*****"
    SpellAmount = s
    
End Function

Private Function SpellDigit(Digit As Integer) As String
    
    Select Case Digit
        Case 1
            SpellDigit = "One "
        Case 2
            SpellDigit = "Two "
        Case 3
            SpellDigit = "Three "
        Case 4
            SpellDigit = "Four "
        Case 5
            SpellDigit = "Five "
        Case 6
            SpellDigit = "Six "
        Case 7
            SpellDigit = "Seven "
        Case 8
            SpellDigit = "Eight "
        Case 9
            SpellDigit = "Nine "
    End Select

End Function
